const express = require('express');

const schoolApp = express();

const libs = `${process.cwd()}/libs`;

const squel = require('squel');

const query = require(`${libs}/middlewares/query`);

const response = require(`${libs}/middlewares/response`);

/**
 * YOU SHALL NOT PASS
 * Esta rota foi desabilitada pois é mais violenta que clube da luta batendo em laranja mecânica
 * A api fica sobrecarregada
 * Pense na cena do elevador de driver mas o elevador é uma bomba de fusão e demora mais que uma luta do DBz
 */
// schoolApp.get('/', (req, res, next) => {
//     req.sql = squel.select().from('escolas')
//         .field('pk_escola_id')
//         .field('nome_entidade', 'name')
//         .field('ano_censo', 'year')
//         .field('fk_cod_estado')
//         .field('fk_cod_municipio')
//         .toParam();
//     next();
// }, query, response('school'));

schoolApp.get('/:id', (req, res, next) => {
    req.sql = squel.select().from('escolas').where('pk_escola_id = ?',
        parseInt(req.params.id, 10)).toParam();
    next();
}, query, response('school'));

schoolApp.get('/state/:id', (req, res, next) => {
    req.sql = squel.select().from('escolas')
        .field('pk_escola_id')
        .field('nome_entidade', 'name')
        .field('ano_censo', 'year')
        .field('fk_cod_estado')
        .field('fk_cod_municipio')
        .where('fk_cod_estado = ?',
        parseInt(req.params.id, 10))
        .toParam();
    next();
}, query, response('school'));

schoolApp.get('/city/:id', (req, res, next) => {
    req.sql = squel.select().from('escolas')
        .field('pk_escola_id')
        .field('nome_entidade', 'name')
        .field('ano_censo', 'year')
        .field('fk_cod_estado')
        .field('fk_cod_municipio')
        .where('fk_cod_municipio = ?',
        parseInt(req.params.id, 10))
        .toParam();
    next();
}, query, response('school'));

module.exports = schoolApp;
